diff --git a/test/functional/compute_resources_vms_controller_test.rb b/test/functional/compute_resources_vms_controller_test.rb
index 3ffd5b0b1..04d32bc9e 100644
--- a/test/functional/compute_resources_vms_controller_test.rb
+++ b/test/functional/compute_resources_vms_controller_test.rb
@@ -12,6 +12,10 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
 #    Fog.unmock!
   end
 
+  def setup_user operation, type = 'compute_resources_vms'
+    super(operation, type, "id = #{@compute_resource.id}")
+  end
+
   test "should not get index when not permitted" do
     setup_user "none"
     get :index, {:compute_resource_id => @compute_resource.to_param}, set_session_user
@@ -34,7 +38,7 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
   test "should not show vm JSON when restricted" do
     setup_user "view"
     get :show, {:id => @test_vm.uuid, :format => "json", :compute_resource_id => @your_compute_resource.to_param}, set_session_user
-    assert_response 403
+    assert_response 404
   end
 
   test "should show vm JSON" do
@@ -52,7 +56,7 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
   test "should not show vm when restricted" do
     setup_user "view"
     get :show, {:id => @test_vm.uuid, :compute_resource_id => @your_compute_resource.to_param}, set_session_user
-    assert_response 403
+    assert_response 404
   end
 
   test "should show vm" do
@@ -73,7 +77,9 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
   #Broken with Fog.mock! because lib/fog/libvirt/models/compute/volume.rb:41 calls create_volume with the wrong number of arguments
   #Broken before Fog 8d95d5bff223a199d33e297ea21884d8598f6921 because default pool name being "default-pool" and not "default" (with test:///default) triggers an internal bug
   def test_should_create_vm(name = "new_test")
-    setup_user "create"
+    setup_user "create" do |user|
+      user.roles.last.add_permissions! :view_compute_resources
+    end
     assert_difference('@compute_resource.vms.count', +1) do
       attrs = {:name => name, :memory => 128*1024*1024, :domain_type => "test", :arch => "i686"}
       post :create, {:vm => attrs, :compute_resource_id => @compute_resource.to_param}, set_session_user
@@ -96,7 +102,7 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
       delete :destroy, {:format => "json", :id => @test_vm.uuid, :compute_resource_id => @your_compute_resource.to_param}, set_session_user
     end
 
-    assert_response 403
+    assert_response 404
   end
 
   test "should destroy vm" do
@@ -127,7 +133,7 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
     setup_user "power"
     get :power, {:format => "json", :id => @test_vm.uuid, :compute_resource_id => @your_compute_resource.to_param}, set_session_user
 
-    assert_response 403
+    assert_response 404
   end
 
   test "should pause openstack vm" do
@@ -173,18 +179,4 @@ class ComputeResourcesVmsControllerTest < ActionController::TestCase
     SETTINGS[:login] ? {:user => User.current.id, :expires_at => 5.minutes.from_now} : {}
   end
 
-  def setup_user operation
-    @one = users(:one)
-    @request.session[:user] = @one.id
-    as_admin do
-      @one.roles = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
-      role = Role.find_or_create_by_name :name => "#{operation}_compute_resources_vms"
-      role.permissions = ["#{operation}_compute_resources_vms".to_sym]
-      role.save!
-      @one.roles << [role]
-      @one.compute_resources = [@compute_resource]
-      @one.save!
-    end
-    User.current = @one
-  end
 end
diff --git a/test/functional/hostgroups_controller_test.rb b/test/functional/hostgroups_controller_test.rb
index 059297ef7..824b5c0f7 100644
--- a/test/functional/hostgroups_controller_test.rb
+++ b/test/functional/hostgroups_controller_test.rb
@@ -58,17 +58,8 @@ class HostgroupsControllerTest < ActionController::TestCase
     assert !Hostgroup.exists?(hostgroup.id)
   end
 
-  def setup_user operation
-    @request.session[:user] = users(:one).id
-    @one = users(:one)
-    as_admin do
-      @one.roles = [Role.find_by_name('Anonymous'), Role.find_by_name('Viewer')]
-      role = Role.find_or_create_by_name :name => "hostgroups"
-      role.permissions = ["#{operation}_hostgroups".to_sym]
-      role.save!
-      @one.roles << [role]
-      @one.save!
-    end
+  def setup_user operation, type = 'hostgroups'
+    super
   end
 
   test 'user with viewer rights should fail to edit a hostgroup ' do
diff --git a/test/functional/hosts_controller_test.rb b/test/functional/hosts_controller_test.rb
index 028304497..2e93d5a29 100644
--- a/test/functional/hosts_controller_test.rb
+++ b/test/functional/hosts_controller_test.rb
@@ -138,144 +138,85 @@ class HostsControllerTest < ActionController::TestCase
     refute assigns(:host).mac
   end
 
-  def setup_user_and_host operation
+  def setup_user operation, type = 'hosts', filter = nil
+    super
+  end
+
+  def setup_user_and_host(operation, filter = nil, &block)
+    setup_user operation, 'hosts', filter, &block
+
     as_admin do
-      @one             = users(:one)
-      @one.domains.destroy_all
-      @one.hostgroups.destroy_all
-      @one.user_facts.destroy_all
       @host1           = hosts(:one)
       @host1.owner     = users(:admin)
       @host1.save!
       @host2           = hosts(:two)
       @host2.owner     = users(:admin)
       @host2.save!
-      @one.roles       = [Role.find_by_name('Anonymous'), Role.find_by_name("#{operation.capitalize} hosts")]
     end
     Host.per_page == 1000
     @request.session[:user] = @one.id
   end
 
-  test 'user with edit host rights and domain is set should succeed in viewing host1' do
-    setup_user_and_host "Edit"
+  test 'user with view host rights and domain is set should succeed in viewing host1 but fail for host2' do
+    setup_user_and_host "view", "domain_id = #{domains(:mydomain).id}"
+
     as_admin do
-      @one.domains  = [domains(:mydomain)]
       @host1.update_attribute(:domain, domains(:mydomain))
       @host2.update_attribute(:domain, domains(:yourdomain))
     end
     get :index, {}, set_session_user.merge(:user => @one.id)
     assert_response :success
     assert_match /#{@host1.shortname}/, @response.body
+    refute_match /#{@host2.name}/, @response.body
   end
 
-  test 'user with edit host rights and domain is set should fail to view host2' do
-    setup_user_and_host "Edit"
-    as_admin do
-      @one.domains  = [domains(:mydomain)]
-      @host1.domain = domains(:mydomain)
-      @host2.domain = domains(:yourdomain)
-    end
-    get :index, {}, set_session_user.merge(:user => @one.id)
-    assert_response :success
-    assert @response.body !~ /#{@host2.name}/
-  end
-
-  test 'user with edit host rights and ownership is set should succeed in viewing host1' do
-    setup_user_and_host "Edit"
-    as_admin do
-      @host1.owner = @one
-      @host2.owner = users(:two)
-      @one.filter_on_owner = true
-      @one.save!
-      @host1.save!
-      @host2.save!
-    end
-    get :index, {}, set_session_user.merge(:user => @one.id)
-    assert_response :success
-    assert @response.body =~ /#{@host1.name}/
-  end
-
-  test 'user with edit host rights and ownership is set should fail to view host2' do
-    setup_user_and_host "Edit"
+  test 'user with view host rights and ownership is set should succeed in viewing host1 but fail for host2' do
+    setup_user_and_host "view", "owner_id = #{users(:one).id} and owner_type = User"
     as_admin do
       @host1.owner = @one
       @host2.owner = users(:two)
-      @one.filter_on_owner = true
-      @one.save!
       @host1.save!
       @host2.save!
     end
     get :index, {}, set_session_user.merge(:user => @one.id)
     assert_response :success
-    assert @response.body !~ /#{@host2.name}/
+    assert_match /#{@host1.name}/, @response.body
+    refute_match /#{@host2.name}/, @response.body
   end
 
-  test 'user with edit host rights and hostgroup is set should succeed in viewing host1' do
-    setup_user_and_host "Edit"
+  test 'user with view host rights and hostgroup is set should succeed in viewing host1 but fail for host2' do
+    setup_user_and_host "view", "hostgroup_id = #{hostgroups(:common).id}"
     as_admin do
       @host1.hostgroup = hostgroups(:common)
       @host2.hostgroup = hostgroups(:unusual)
-      @one.hostgroups  = [hostgroups(:common)]
       @host1.save!
       @host2.save!
     end
     get :index, {}, set_session_user.merge(:user => @one.id)
     assert_response :success
-    assert @response.body =~ /#{@host1.name}/
+    assert_match /#{@host1.name}/, @response.body
+    refute_match /#{@host2.name}/, @response.body
   end
 
-  test 'user with edit host rights and hostgroup is set should fail to view host2' do
-    setup_user_and_host "Edit"
-    as_admin do
-      @host1.hostgroup = hostgroups(:common)
-      @host2.hostgroup = hostgroups(:unusual)
-      @one.hostgroups  = [hostgroups(:common)]
-      @host1.save!
-      @host2.save!
-    end
-    get :index, {}, set_session_user.merge(:user => @one.id)
-    assert_response :success
-    assert @response.body !~ /#{@host2.name}/
-  end
-
-  test 'user with edit host rights and facts are set should succeed in viewing host1' do
-    setup_user_and_host "Edit"
+  test 'user with edit host rights and facts are set should succeed in viewing host1 but fail for host2' do
+    setup_user_and_host "view", "facts.architecture = \"x86_64\""
     as_admin do
       fn_id = FactName.find_or_create_by_name("architecture").id
       FactValue.create! :host => @host1, :fact_name_id => fn_id, :value    => "x86_64"
       FactValue.create! :host => @host2, :fact_name_id => fn_id, :value    => "i386"
-      UserFact.create!  :user => @one,   :fact_name_id => fn_id, :criteria => "x86_64", :operator => "=", :andor => "or"
     end
     get :index, {}, set_session_user.merge(:user => @one.id)
     assert_response :success
-    assert @response.body =~ /#{@host1.name}/
-  end
-
-  test 'user with edit host rights and facts are set should fail to view host2' do
-    setup_user_and_host "Edit"
-    as_admin do
-      fn_id = FactName.find_or_create_by_name("architecture").id
-      FactValue.create! :host => @host1, :fact_name_id => fn_id, :value    => "x86_64"
-      FactValue.create! :host => @host2, :fact_name_id => fn_id, :value    => "i386"
-      UserFact.create!  :user => @one,   :fact_name_id => fn_id, :criteria => "x86_64", :operator => "=", :andor => "or"
-    end
-    get :index, {}, set_session_user.merge(:user => @one.id)
-    assert_response :success
-    assert @response.body !~ /#{@host2.name}/
+    assert_match /#{@host1.name}/, @response.body
+    refute_match /#{@host2.name}/, @response.body
   end
 
   test 'user with view host rights should fail to edit host' do
-    setup_user_and_host "View"
+    setup_user_and_host "view"
     get :edit, {:id => @host1.id}, set_session_user.merge(:user => @one.id)
     assert_equal @response.status, 403
   end
 
-  test 'user with view host rights should should succeed in viewing hosts' do
-    setup_user_and_host "View"
-    get :index, {}, set_session_user.merge(:user => @one.id)
-    assert_response :success
-  end
-
   test 'multiple without hosts' do
     post :update_multiple_hostgroup, {}, set_session_user
     assert_redirected_to hosts_url
@@ -296,6 +237,7 @@ class HostsControllerTest < ActionController::TestCase
 
     hostgroup = hostgroups(:unusual)
     post :update_multiple_hostgroup, { :host_ids => hosts.map(&:id), :hostgroup => { :id => hostgroup.id } }, set_session_user
+    assert_response :redirect
 
     # reloads hosts
     hosts.map! {|h| Host.find(h.id)}
@@ -315,6 +257,7 @@ class HostsControllerTest < ActionController::TestCase
 
     hostgroup = hostgroups(:common)
     post :update_multiple_hostgroup, { :host_names => host_names, :hostgroup  => { :id => hostgroup.id} }, set_session_user
+    assert_response :redirect
 
     host_names.each do |name|
       host = Host.find_by_name name
@@ -466,7 +409,7 @@ class HostsControllerTest < ActionController::TestCase
   def test_set_manage
     @request.env['HTTP_REFERER'] = edit_host_path @host
     assert @host.update_attribute :managed, false
-    assert @host.errors.empty?
+    assert_empty @host.errors
     put :toggle_manage, {:id => @host.name}, set_session_user
     assert_redirected_to :controller => :hosts, :action => :edit
     assert flash[:notice] == "Foreman now manages the build cycle for #{@host.name}"
@@ -475,7 +418,7 @@ class HostsControllerTest < ActionController::TestCase
   def test_unset_manage
     @request.env['HTTP_REFERER'] = edit_host_path @host
     assert @host.update_attribute :managed, true
-    assert @host.errors.empty?
+    assert_empty @host.errors
     put :toggle_manage, {:id => @host.name}, set_session_user
     assert_redirected_to :controller => :hosts, :action => :edit
     assert flash[:notice] == "Foreman now no longer manages the build cycle for #{@host.name}"
@@ -781,7 +724,7 @@ class HostsControllerTest < ActionController::TestCase
   test "index returns YAML output for rundeck" do
     get :index, {:format => 'yaml', :rundeck => true}, set_session_user
     hosts = YAML.load(@response.body)
-    assert !hosts.empty?
+    assert_not_empty hosts
     host = Host.first
     assert_equal host.os.name, hosts[host.name]["osName"]  # rundeck-specific field
   end
diff --git a/test/functional/roles_controller_test.rb b/test/functional/roles_controller_test.rb
index 0353e516e..311f80519 100644
--- a/test/functional/roles_controller_test.rb
+++ b/test/functional/roles_controller_test.rb
@@ -19,7 +19,7 @@ require 'test_helper'
 
 class RolesControllerTest < ActionController::TestCase
 
-  def test_get_index
+  test 'get index' do
     get :index, {}, set_session_user
     assert_response :success
     assert_template 'index'
@@ -31,49 +31,52 @@ class RolesControllerTest < ActionController::TestCase
       :content => 'Manager'
   end
 
-  def test_get_new
+  test 'get new' do
     get :new, {}, set_session_user
     assert_response :success
     assert_template 'new'
   end
 
-  def test_post_new_with_validaton_failure
-    post :create, { :role => {:name => '',
-      :permissions => ['add_hosts', 'edit_hosts', 'edit_ptables', '']
-    }}, set_session_user
+  test 'empty name validation' do
+    post :create, { :role => {:name => ''}}, set_session_user
 
     assert_response :success
     assert_template 'new'
   end
 
-  def test_get_edit
+  test 'creates role' do
+    post :create, { :role => {:name => 'test role'}}, set_session_user
+
+    assert_redirected_to roles_path
+    assert Role.find_by_name('test role')
+  end
+
+  test 'get edit goes to right template' do
     get :edit, {:id => 1}, set_session_user
     assert_response :success
     assert_template 'edit'
     assert_equal Role.find(1), assigns(:role)
   end
 
-  def test_post_edit
-    put :update, {:id => 1,
-      :role => {:name => 'Manager',
-        :permissions => ['edit_hosts']
-    }}, set_session_user
+  test 'put edit updates role' do
+    role = FactoryGirl.create(:role)
+    put :update, {:id => role.id, :role => {:name => 'masterManager'}}, set_session_user
 
     assert_redirected_to roles_path
-    role = Role.find(1)
-    assert_equal [:edit_hosts], role.permissions
+    role.reload
+    assert_equal 'masterManager', role.name
   end
 
-  def test_destroy
-    r = Role.new(:name => 'ToBeDestroyed', :permissions => [:view_ptables])
-    assert r.save
+  test 'delete destroy removes role' do
+    role = FactoryGirl.build(:role, :name => 'ToBeDestroyed')
+    role.add_permissions! :view_ptables
 
-    delete :destroy, {:id => r}, set_session_user
+    delete :destroy, {:id => role}, set_session_user
     assert_redirected_to roles_path
-    assert_nil Role.find_by_id(r.id)
+    assert_nil Role.find_by_id(role.id)
   end
 
-  def test_destroy_role_in_use
+  test 'roles in use cannot be destroyed' do
     users(:one).roles = [roles(:manager)] # make user one a manager
     delete :destroy, {:id => roles(:manager)}, set_session_user
     assert_redirected_to roles_path
@@ -81,29 +84,28 @@ class RolesControllerTest < ActionController::TestCase
     assert_not_nil Role.find_by_id(roles(:manager).id)
   end
 
-  def test_get_report
-    get :report, {}, set_session_user
-    assert_response :success
-    assert_template 'report'
-
-    assert_not_nil assigns(:roles)
-    assert_equal Role.all.sort, assigns(:roles).sort
-
-  end
-
-  def test_post_report
-    post :report, { :permissions => { '0' => '', '1' => ['edit_issues'], '3' => ['add_issues', 'delete_issues']} }, set_session_user
-    assert_redirected_to roles_path
-
-    assert_equal [:edit_issues], Role.find(1).permissions
-    assert_equal [:add_issues, :delete_issues], Role.find(3).permissions
-    assert Role.find(2).permissions.empty?
-  end
-
-  def test_clear_all_permissions
-    post :report, { :permissions => { '0' => '' } }, set_session_user
-    assert_redirected_to roles_path
-    assert Role.find(1).permissions.empty?
+  context 'clone' do
+    setup do
+      @role = FactoryGirl.build(:role, :name => 'ToBeDestroyed')
+      @role.add_permissions! :view_ptables
+    end
+
+    test 'renders new page with hidden field original_role_id' do
+      get :clone, { :id => @role.id } , set_session_user
+      assert_template 'new'
+    end
+
+    test 'original_role_id is used to create cloned role if set' do
+      params = { :role => {:name => 'clonedrole'},
+                 :original_role_id => @role.id,
+                 :cloned_role => true }
+      post :create, params, set_session_user
+      assert_redirected_to roles_url
+
+      cloned_role = Role.find_by_name('clonedrole')
+      assert_not_nil cloned_role
+      assert_equal @role.permissions, cloned_role.permissions
+    end
   end
 
 end
diff --git a/test/functional/users_controller_test.rb b/test/functional/users_controller_test.rb
index 19b52820b..06e702bcd 100644
--- a/test/functional/users_controller_test.rb
+++ b/test/functional/users_controller_test.rb
@@ -136,7 +136,7 @@ class UsersControllerTest < ActionController::TestCase
 
   test 'user with viewer rights should fail to edit a user' do
     get :edit, {:id => User.first.id}
-    assert_response 403
+    assert_response 404
   end
 
   test 'user with viewer rights should succeed in viewing users' do
@@ -233,16 +233,29 @@ class UsersControllerTest < ActionController::TestCase
     assert_response :redirect
   end
 
-  test 'non admin user should not be able to edit another user' do
+  test 'user without edit permission should not be able to edit another user' do
     User.current = users(:one)
     get :edit, { :id => users(:two) }
-    assert_response 403
+    assert_response 404
+  end
+
+  test 'user with edit permission should be able to edit another user' do
+    setup_user 'edit', 'users'
+    get :edit, { :id => users(:two) }
+    assert_response :success
   end
 
-  test 'non admin user should not be able to update another user' do
+  test 'user without edit permission should not be able to update another user' do
     User.current = users(:one)
     put :update, { :id => users(:two).id, :user => { :firstname => 'test' } }
     assert_response 403
   end
 
+  test 'user with update permission should be able to update another user' do
+    setup_user 'edit', 'users'
+    put :update, { :id => users(:two).id, :user => { :firstname => 'test' } }
+
+    assert_response :redirect
+  end
+
 end
diff --git a/test/test_helper.rb b/test/test_helper.rb
index 59b689285..a359c5b14 100644
--- a/test/test_helper.rb
+++ b/test/test_helper.rb
@@ -42,6 +42,27 @@ Spork.prefork do
     set_fixture_class({ :hosts => Host::Base })
     set_fixture_class :nics => Nic::BMC
 
+    setup :begin_gc_deferment
+    teardown :reconsider_gc_deferment
+
+    DEFERRED_GC_THRESHOLD = (ENV['DEFER_GC'] || 1.0).to_f
+
+    @@last_gc_run = Time.now
+
+    def begin_gc_deferment
+      GC.disable if DEFERRED_GC_THRESHOLD > 0
+    end
+
+    def reconsider_gc_deferment
+      if DEFERRED_GC_THRESHOLD > 0 && Time.now - @@last_gc_run >= DEFERRED_GC_THRESHOLD
+        GC.enable
+        GC.start
+        GC.disable
+
+        @@last_gc_run = Time.now
+      end
+    end
+
     # for backwards compatibility to between Minitest syntax
     alias_method :assert_not,       :refute
     alias_method :assert_no_match,  :refute_match
@@ -82,12 +103,20 @@ Spork.prefork do
       user.save!
     end
 
-    def setup_user operation, type=""
-      @one = users(:one)
+    # if a method receieves a block it will be yielded just before user save
+    def setup_user operation, type="", search = nil, user = :one
+      @one = users(user)
       as_admin do
+        permission = Permission.find_by_name("#{operation}_#{type}") || FactoryGirl.create(:permission, :name => "#{operation}_#{type}")
+        filter = FactoryGirl.build(:filter, :search => search)
+        filter.permissions = [ permission ]
         role = Role.find_or_create_by_name :name => "#{operation}_#{type}"
-        role.permissions = ["#{operation}_#{type}".to_sym]
-        @one.roles = [role]
+        role.filters = [ filter ]
+        role.save!
+        filter.role = role
+        filter.save!
+        @one.roles = [ role ]
+        yield(@one) if block_given?
         @one.save!
       end
       User.current = @one
diff --git a/test/unit/architecture_test.rb b/test/unit/architecture_test.rb
index 26c0f03fc..ff61a1d62 100644
--- a/test/unit/architecture_test.rb
+++ b/test/unit/architecture_test.rb
@@ -6,19 +6,19 @@ class ArchitectureTest < ActiveSupport::TestCase
   end
   test "should not save without a name" do
     architecture = Architecture.new
-    assert !architecture.save
+    assert_not architecture.save
   end
 
   test "name should not be blank" do
     architecture = Architecture.new :name => "   "
-    assert architecture.name.strip.empty?
-    assert !architecture.save
+    assert_empty architecture.name.strip
+    assert_not architecture.save
   end
 
   test "name should not contain white spaces" do
     architecture = Architecture.new :name => " i38  6 "
-    assert !architecture.name.squeeze(" ").tr(' ', '').empty?
-    assert !architecture.save
+    assert_not_empty architecture.name.squeeze(" ").tr(' ', '')
+    assert_not architecture.save
 
     architecture.name.squeeze!(" ").tr!(' ', '')
     assert architecture.save
@@ -29,7 +29,7 @@ class ArchitectureTest < ActiveSupport::TestCase
     assert architecture.save
 
     other_architecture = Architecture.new :name => "i386"
-    assert !other_architecture.save
+    assert_not other_architecture.save
   end
 
   test "to_s retrives name" do
@@ -45,63 +45,7 @@ class ArchitectureTest < ActiveSupport::TestCase
     host.architecture = architecture
     host.save(:validate => false)
 
-    assert !architecture.destroy
+    assert_not architecture.destroy
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_architectures"
-      role.permissions = ["#{operation}_architectures".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  Architecture.create :name => "dummy"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  Architecture.create :name => "dummy"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  Architecture.first
-    as_admin do
-      record.hosts.delete_all
-      record.hostgroups.delete_all
-    end
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Architecture.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Architecture.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Architecture.first
-    record.name = "renamed"
-    assert !record.save
-  end
 end
diff --git a/test/unit/auth_source_ldap_test.rb b/test/unit/auth_source_ldap_test.rb
index 3d7e587ac..d7a0c58c8 100644
--- a/test/unit/auth_source_ldap_test.rb
+++ b/test/unit/auth_source_ldap_test.rb
@@ -175,59 +175,4 @@ class AuthSourceLdapTest < ActiveSupport::TestCase
     @auth_source_ldap.send method, "this is010this is020this is030this is040this is050this is060this is070this is080this is090this is100this is110this is120this is130this is140this is150this is160this is170this is180this is190this is200this is210this is220this is230this is240this is250 and something else"
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_authenticators"
-      role.permissions = ["#{operation}_authenticators".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  AuthSourceLdap.create :name => "dummy", :host => hosts(:one).name, :port => "1", :attr_login => "login"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  AuthSourceLdap.create :name => "dummy", :host => hosts(:one).name, :port => "1", :attr_login => "login"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  AuthSourceLdap.first
-    as_admin do
-      record.users.delete_all
-    end
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  AuthSourceLdap.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  AuthSourceLdap.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  AuthSourceLdap.first
-    record.name = "renamed"
-    assert !record.save
-  end
 end
